<html>
<head>
<title>OGRE: Ogre::ShadowListener Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1ShadowListener.html">ShadowListener</a></div>
<h1>Ogre::ShadowListener Class Reference</h1><!-- doxytag: class="Ogre::ShadowListener" -->Interface definition for classes which can listen in on the process of rendering shadows, in order to implement custom behaviour.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreSceneManager_8h-source.html">OgreSceneManager.h</a>&gt;</code>
<p>

<p>
<a href="classOgre_1_1ShadowListener-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowListener.html#e25c4f183cf7ee81785ed6a94d0cce4d">ShadowListener</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowListener.html#b2d690f1833a7aa89ee78134ddb60cab">~ShadowListener</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowListener.html#0e88a5ee4e011607a6f959bcfc0bbc74">shadowTexturesUpdated</a> (size_t numberOfShadowTextures)=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Event raised after all shadow textures have been rendered into for all queues / targets but before any other geometry has been rendered (including main scene geometry and any additional shadow receiver passes).  <a href="#0e88a5ee4e011607a6f959bcfc0bbc74"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowListener.html#0170ae3d08dd9fffeb61187148e46fc1">shadowTextureCasterPreViewProj</a> (<a class="el" href="classOgre_1_1Light.html">Light</a> *light, <a class="el" href="classOgre_1_1Camera.html">Camera</a> *camera)=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This event occurs just before the view &amp; projection matrices are set for rendering into a shadow texture.  <a href="#0170ae3d08dd9fffeb61187148e46fc1"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowListener.html#4c56cfe8267df423dbf9d1b1ed835036">shadowTextureReceiverPreViewProj</a> (<a class="el" href="classOgre_1_1Light.html">Light</a> *light, <a class="el" href="classOgre_1_1Frustum.html">Frustum</a> *frustum)=0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This event occurs just before the view &amp; projection matrices are set for re-rendering a shadow receiver.  <a href="#4c56cfe8267df423dbf9d1b1ed835036"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowListener.html#1c58e9641408d3e532a0ccac3b69ca3f">sortLightsAffectingFrustum</a> (<a class="el" href="namespaceOgre.html#b82c6299605910b4051ebb3cc3e5539e">LightList</a> &amp;lightList)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Hook to allow the listener to override the ordering of lights for the entire frustum.  <a href="#1c58e9641408d3e532a0ccac3b69ca3f"></a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Interface definition for classes which can listen in on the process of rendering shadows, in order to implement custom behaviour. 
<p>Definition at line <a class="el" href="OgreSceneManager_8h-source.html#l00110">110</a> of file <a class="el" href="OgreSceneManager_8h-source.html">OgreSceneManager.h</a>.</p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="e25c4f183cf7ee81785ed6a94d0cce4d"></a><!-- doxytag: member="Ogre::ShadowListener::ShadowListener" ref="e25c4f183cf7ee81785ed6a94d0cce4d" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::ShadowListener::ShadowListener           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreSceneManager_8h-source.html#l00113">113</a> of file <a class="el" href="OgreSceneManager_8h-source.html">OgreSceneManager.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="b2d690f1833a7aa89ee78134ddb60cab"></a><!-- doxytag: member="Ogre::ShadowListener::~ShadowListener" ref="b2d690f1833a7aa89ee78134ddb60cab" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual Ogre::ShadowListener::~ShadowListener           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreSceneManager_8h-source.html#l00114">114</a> of file <a class="el" href="OgreSceneManager_8h-source.html">OgreSceneManager.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="0e88a5ee4e011607a6f959bcfc0bbc74"></a><!-- doxytag: member="Ogre::ShadowListener::shadowTexturesUpdated" ref="0e88a5ee4e011607a6f959bcfc0bbc74" args="(size_t numberOfShadowTextures)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::ShadowListener::shadowTexturesUpdated           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>numberOfShadowTextures</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Event raised after all shadow textures have been rendered into for all queues / targets but before any other geometry has been rendered (including main scene geometry and any additional shadow receiver passes). 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This callback is useful for those that wish to perform some additional processing on shadow textures before they are used to render shadows. For example you could perform some filtering by rendering the existing shadow textures into another alternative shadow texture with a shader.] </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>This event will only be fired when texture shadows are in use. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>numberOfShadowTextures</em>&nbsp;</td><td>The number of shadow textures in use </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="0170ae3d08dd9fffeb61187148e46fc1"></a><!-- doxytag: member="Ogre::ShadowListener::shadowTextureCasterPreViewProj" ref="0170ae3d08dd9fffeb61187148e46fc1" args="(Light *light, Camera *camera)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::ShadowListener::shadowTextureCasterPreViewProj           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Light.html">Light</a> *&nbsp;</td>
          <td class="paramname"> <em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Camera.html">Camera</a> *&nbsp;</td>
          <td class="paramname"> <em>camera</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
This event occurs just before the view &amp; projection matrices are set for rendering into a shadow texture. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>You can use this event hook to perform some custom processing, such as altering the camera being used for rendering the light's view, including setting custom view &amp; projection matrices if you want to perform an advanced shadow technique. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>This event will only be fired when texture shadows are in use. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>light</em>&nbsp;</td><td>Pointer to the light for which shadows are being rendered </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>camera</em>&nbsp;</td><td>Pointer to the camera being used to render </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="4c56cfe8267df423dbf9d1b1ed835036"></a><!-- doxytag: member="Ogre::ShadowListener::shadowTextureReceiverPreViewProj" ref="4c56cfe8267df423dbf9d1b1ed835036" args="(Light *light, Frustum *frustum)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::ShadowListener::shadowTextureReceiverPreViewProj           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Light.html">Light</a> *&nbsp;</td>
          <td class="paramname"> <em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Frustum.html">Frustum</a> *&nbsp;</td>
          <td class="paramname"> <em>frustum</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
This event occurs just before the view &amp; projection matrices are set for re-rendering a shadow receiver. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>You can use this event hook to perform some custom processing, such as altering the projection frustum being used for rendering the shadow onto the receiver to perform an advanced shadow technique. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>This event will only be fired when texture shadows are in use. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>light</em>&nbsp;</td><td>Pointer to the light for which shadows are being rendered </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>frustum</em>&nbsp;</td><td>Pointer to the projection frustum being used to project the shadow texture </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="1c58e9641408d3e532a0ccac3b69ca3f"></a><!-- doxytag: member="Ogre::ShadowListener::sortLightsAffectingFrustum" ref="1c58e9641408d3e532a0ccac3b69ca3f" args="(LightList &amp;lightList)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Ogre::ShadowListener::sortLightsAffectingFrustum           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#b82c6299605910b4051ebb3cc3e5539e">LightList</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>lightList</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Hook to allow the listener to override the ordering of lights for the entire frustum. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Whilst ordinarily lights are sorted per rendered object (</dd></dl>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1MovableObject.html#2d4c926ce07f3a1cb0e59d9d60aac76b" title="Gets a list of lights, ordered relative to how close they are to this movable object...">MovableObject::queryLights</a>), texture shadows adds another issue in that, given there is a finite number of shadow textures, we must choose which lights to render texture shadows from based on the entire frustum. These lights should always be listed first in every objects own list, followed by any other lights which will not cast texture shadows (either because they have shadow casting off, or there aren't enough shadow textures to service them). </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>This hook allows you to override the detailed ordering of the lights per frustum. The default ordering is shadow casters first (which you must also respect if you override this method), and ordered by distance from the camera within those 2 groups. Obviously the closest lights with shadow casting enabled will be listed first. Only lights within the range of the frustum will be in the list. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>lightList</em>&nbsp;</td><td>The list of lights within range of the frustum which you may sort. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>true if you sorted the list, false otherwise. </dd></dl>

<p>Definition at line <a class="el" href="OgreSceneManager_8h-source.html#l00184">184</a> of file <a class="el" href="OgreSceneManager_8h-source.html">OgreSceneManager.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreSceneManager_8h-source.html">OgreSceneManager.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:52:49 2008
</p>
</body>
</html>
